{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 31,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/javascript": [
       "\n",
       "(function(root) {\n",
       "  function now() {\n",
       "    return new Date();\n",
       "  }\n",
       "\n",
       "  var force = true;\n",
       "\n",
       "  if (typeof root._bokeh_onload_callbacks === \"undefined\" || force === true) {\n",
       "    root._bokeh_onload_callbacks = [];\n",
       "    root._bokeh_is_loading = undefined;\n",
       "  }\n",
       "\n",
       "  if (typeof (root._bokeh_timeout) === \"undefined\" || force === true) {\n",
       "    root._bokeh_timeout = Date.now() + 5000;\n",
       "    root._bokeh_failed_load = false;\n",
       "  }\n",
       "\n",
       "  function run_callbacks() {\n",
       "    try {\n",
       "      root._bokeh_onload_callbacks.forEach(function(callback) {\n",
       "        if (callback != null)\n",
       "          callback();\n",
       "      });\n",
       "    } finally {\n",
       "      delete root._bokeh_onload_callbacks\n",
       "    }\n",
       "    console.debug(\"Bokeh: all callbacks have finished\");\n",
       "  }\n",
       "\n",
       "  function load_libs(css_urls, js_urls, callback) {\n",
       "    if (css_urls == null) css_urls = [];\n",
       "    if (js_urls == null) js_urls = [];\n",
       "\n",
       "    root._bokeh_onload_callbacks.push(callback);\n",
       "    if (root._bokeh_is_loading > 0) {\n",
       "      console.debug(\"Bokeh: BokehJS is being loaded, scheduling callback at\", now());\n",
       "      return null;\n",
       "    }\n",
       "    if (js_urls == null || js_urls.length === 0) {\n",
       "      run_callbacks();\n",
       "      return null;\n",
       "    }\n",
       "    console.debug(\"Bokeh: BokehJS not loaded, scheduling load and callback at\", now());\n",
       "    root._bokeh_is_loading = css_urls.length + js_urls.length;\n",
       "\n",
       "    function on_load() {\n",
       "      root._bokeh_is_loading--;\n",
       "      if (root._bokeh_is_loading === 0) {\n",
       "        console.debug(\"Bokeh: all BokehJS libraries/stylesheets loaded\");\n",
       "        run_callbacks()\n",
       "      }\n",
       "    }\n",
       "\n",
       "    function on_error() {\n",
       "      console.error(\"failed to load \" + url);\n",
       "    }\n",
       "\n",
       "    for (var i = 0; i < css_urls.length; i++) {\n",
       "      var url = css_urls[i];\n",
       "      const element = document.createElement(\"link\");\n",
       "      element.onload = on_load;\n",
       "      element.onerror = on_error;\n",
       "      element.rel = \"stylesheet\";\n",
       "      element.type = \"text/css\";\n",
       "      element.href = url;\n",
       "      console.debug(\"Bokeh: injecting link tag for BokehJS stylesheet: \", url);\n",
       "      document.body.appendChild(element);\n",
       "    }\n",
       "\n",
       "    var skip = [];\n",
       "    if (window.requirejs) {\n",
       "      require([], function() {\n",
       "      })\n",
       "    }\n",
       "    for (var i = 0; i < js_urls.length; i++) {\n",
       "      var url = js_urls[i];\n",
       "      if (skip.indexOf(url) >= 0) { on_load(); continue; }\n",
       "      var element = document.createElement('script');\n",
       "      element.onload = on_load;\n",
       "      element.onerror = on_error;\n",
       "      element.async = false;\n",
       "      element.src = url;\n",
       "      console.debug(\"Bokeh: injecting script tag for BokehJS library: \", url);\n",
       "      document.head.appendChild(element);\n",
       "    }\n",
       "\tif (!js_urls.length) {\n",
       "      on_load()\n",
       "    }\n",
       "  };\n",
       "\n",
       "  function inject_raw_css(css) {\n",
       "    const element = document.createElement(\"style\");\n",
       "    element.appendChild(document.createTextNode(css));\n",
       "    document.body.appendChild(element);\n",
       "  }\n",
       "\n",
       "  var js_urls = [\"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.3.min.js\", \"https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.3.min.js\", \"https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.3.min.js\", \"https://unpkg.com/@holoviz/panel@^0.10.1/dist/panel.min.js\"];\n",
       "  var css_urls = [\"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/alerts.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/card.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/dataframe.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/json.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/markdown.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/widgets.css\"];\n",
       "\n",
       "  var inline_js = [\n",
       "    function(Bokeh) {\n",
       "      Bokeh.set_log_level(\"info\");\n",
       "    },\n",
       "    function(Bokeh) {} // ensure no trailing comma for IE\n",
       "  ];\n",
       "\n",
       "  function run_inline_js() {\n",
       "    if ((root.Bokeh !== undefined) || (force === true)) {\n",
       "      for (var i = 0; i < inline_js.length; i++) {\n",
       "        inline_js[i].call(root, root.Bokeh);\n",
       "      }} else if (Date.now() < root._bokeh_timeout) {\n",
       "      setTimeout(run_inline_js, 100);\n",
       "    } else if (!root._bokeh_failed_load) {\n",
       "      console.log(\"Bokeh: BokehJS failed to load within specified timeout.\");\n",
       "      root._bokeh_failed_load = true;\n",
       "    }\n",
       "  }\n",
       "\n",
       "  if (root._bokeh_is_loading === 0) {\n",
       "    console.debug(\"Bokeh: BokehJS loaded, going straight to plotting\");\n",
       "    run_inline_js();\n",
       "  } else {\n",
       "    load_libs(css_urls, js_urls, function() {\n",
       "      console.debug(\"Bokeh: BokehJS plotting callback run at\", now());\n",
       "      run_inline_js();\n",
       "    });\n",
       "  }\n",
       "}(window));"
      ],
      "application/vnd.holoviews_load.v0+json": "\n(function(root) {\n  function now() {\n    return new Date();\n  }\n\n  var force = true;\n\n  if (typeof root._bokeh_onload_callbacks === \"undefined\" || force === true) {\n    root._bokeh_onload_callbacks = [];\n    root._bokeh_is_loading = undefined;\n  }\n\n  if (typeof (root._bokeh_timeout) === \"undefined\" || force === true) {\n    root._bokeh_timeout = Date.now() + 5000;\n    root._bokeh_failed_load = false;\n  }\n\n  function run_callbacks() {\n    try {\n      root._bokeh_onload_callbacks.forEach(function(callback) {\n        if (callback != null)\n          callback();\n      });\n    } finally {\n      delete root._bokeh_onload_callbacks\n    }\n    console.debug(\"Bokeh: all callbacks have finished\");\n  }\n\n  function load_libs(css_urls, js_urls, callback) {\n    if (css_urls == null) css_urls = [];\n    if (js_urls == null) js_urls = [];\n\n    root._bokeh_onload_callbacks.push(callback);\n    if (root._bokeh_is_loading > 0) {\n      console.debug(\"Bokeh: BokehJS is being loaded, scheduling callback at\", now());\n      return null;\n    }\n    if (js_urls == null || js_urls.length === 0) {\n      run_callbacks();\n      return null;\n    }\n    console.debug(\"Bokeh: BokehJS not loaded, scheduling load and callback at\", now());\n    root._bokeh_is_loading = css_urls.length + js_urls.length;\n\n    function on_load() {\n      root._bokeh_is_loading--;\n      if (root._bokeh_is_loading === 0) {\n        console.debug(\"Bokeh: all BokehJS libraries/stylesheets loaded\");\n        run_callbacks()\n      }\n    }\n\n    function on_error() {\n      console.error(\"failed to load \" + url);\n    }\n\n    for (var i = 0; i < css_urls.length; i++) {\n      var url = css_urls[i];\n      const element = document.createElement(\"link\");\n      element.onload = on_load;\n      element.onerror = on_error;\n      element.rel = \"stylesheet\";\n      element.type = \"text/css\";\n      element.href = url;\n      console.debug(\"Bokeh: injecting link tag for BokehJS stylesheet: \", url);\n      document.body.appendChild(element);\n    }\n\n    var skip = [];\n    if (window.requirejs) {\n      require([], function() {\n      })\n    }\n    for (var i = 0; i < js_urls.length; i++) {\n      var url = js_urls[i];\n      if (skip.indexOf(url) >= 0) { on_load(); continue; }\n      var element = document.createElement('script');\n      element.onload = on_load;\n      element.onerror = on_error;\n      element.async = false;\n      element.src = url;\n      console.debug(\"Bokeh: injecting script tag for BokehJS library: \", url);\n      document.head.appendChild(element);\n    }\n\tif (!js_urls.length) {\n      on_load()\n    }\n  };\n\n  function inject_raw_css(css) {\n    const element = document.createElement(\"style\");\n    element.appendChild(document.createTextNode(css));\n    document.body.appendChild(element);\n  }\n\n  var js_urls = [\"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.3.min.js\", \"https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.3.min.js\", \"https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.3.min.js\", \"https://unpkg.com/@holoviz/panel@^0.10.1/dist/panel.min.js\"];\n  var css_urls = [\"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/alerts.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/card.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/dataframe.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/json.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/markdown.css\", \"https://unpkg.com/@holoviz/panel@0.10.1/dist/css/widgets.css\"];\n\n  var inline_js = [\n    function(Bokeh) {\n      Bokeh.set_log_level(\"info\");\n    },\n    function(Bokeh) {} // ensure no trailing comma for IE\n  ];\n\n  function run_inline_js() {\n    if ((root.Bokeh !== undefined) || (force === true)) {\n      for (var i = 0; i < inline_js.length; i++) {\n        inline_js[i].call(root, root.Bokeh);\n      }} else if (Date.now() < root._bokeh_timeout) {\n      setTimeout(run_inline_js, 100);\n    } else if (!root._bokeh_failed_load) {\n      console.log(\"Bokeh: BokehJS failed to load within specified timeout.\");\n      root._bokeh_failed_load = true;\n    }\n  }\n\n  if (root._bokeh_is_loading === 0) {\n    console.debug(\"Bokeh: BokehJS loaded, going straight to plotting\");\n    run_inline_js();\n  } else {\n    load_libs(css_urls, js_urls, function() {\n      console.debug(\"Bokeh: BokehJS plotting callback run at\", now());\n      run_inline_js();\n    });\n  }\n}(window));"
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "if ((window.PyViz === undefined) || (window.PyViz instanceof HTMLElement)) {\n",
       "  window.PyViz = {comms: {}, comm_status:{}, kernels:{}, receivers: {}, plot_index: []}\n",
       "}\n",
       "\n",
       "\n",
       "    function JupyterCommManager() {\n",
       "    }\n",
       "\n",
       "    JupyterCommManager.prototype.register_target = function(plot_id, comm_id, msg_handler) {\n",
       "      if (window.comm_manager || ((window.Jupyter !== undefined) && (Jupyter.notebook.kernel != null))) {\n",
       "        var comm_manager = window.comm_manager || Jupyter.notebook.kernel.comm_manager;\n",
       "        comm_manager.register_target(comm_id, function(comm) {\n",
       "          comm.on_msg(msg_handler);\n",
       "        });\n",
       "      } else if ((plot_id in window.PyViz.kernels) && (window.PyViz.kernels[plot_id])) {\n",
       "        window.PyViz.kernels[plot_id].registerCommTarget(comm_id, function(comm) {\n",
       "          comm.onMsg = msg_handler;\n",
       "        });\n",
       "      } else if (typeof google != 'undefined' && google.colab.kernel != null) {\n",
       "        google.colab.kernel.comms.registerTarget(comm_id, (comm) => {\n",
       "          var messages = comm.messages[Symbol.asyncIterator]();\n",
       "          function processIteratorResult(result) {\n",
       "            var message = result.value;\n",
       "            console.log(message)\n",
       "            var content = {data: message.data, comm_id};\n",
       "            var buffers = []\n",
       "            for (var buffer of message.buffers || []) {\n",
       "              buffers.push(new DataView(buffer))\n",
       "            }\n",
       "            var metadata = message.metadata || {};\n",
       "            var msg = {content, buffers, metadata}\n",
       "            msg_handler(msg);\n",
       "            return messages.next().then(processIteratorResult);\n",
       "          }\n",
       "          return messages.next().then(processIteratorResult);\n",
       "        })\n",
       "      }\n",
       "    }\n",
       "\n",
       "    JupyterCommManager.prototype.get_client_comm = function(plot_id, comm_id, msg_handler) {\n",
       "      if (comm_id in window.PyViz.comms) {\n",
       "        return window.PyViz.comms[comm_id];\n",
       "      } else if (window.comm_manager || ((window.Jupyter !== undefined) && (Jupyter.notebook.kernel != null))) {\n",
       "        var comm_manager = window.comm_manager || Jupyter.notebook.kernel.comm_manager;\n",
       "        var comm = comm_manager.new_comm(comm_id, {}, {}, {}, comm_id);\n",
       "        if (msg_handler) {\n",
       "          comm.on_msg(msg_handler);\n",
       "        }\n",
       "      } else if ((plot_id in window.PyViz.kernels) && (window.PyViz.kernels[plot_id])) {\n",
       "        var comm = window.PyViz.kernels[plot_id].connectToComm(comm_id);\n",
       "        comm.open();\n",
       "        if (msg_handler) {\n",
       "          comm.onMsg = msg_handler;\n",
       "        }\n",
       "      } else if (typeof google != 'undefined' && google.colab.kernel != null) {\n",
       "        var comm_promise = google.colab.kernel.comms.open(comm_id)\n",
       "        comm_promise.then((comm) => {\n",
       "          window.PyViz.comms[comm_id] = comm;\n",
       "          if (msg_handler) {\n",
       "            var messages = comm.messages[Symbol.asyncIterator]();\n",
       "            function processIteratorResult(result) {\n",
       "              var message = result.value;\n",
       "              var content = {data: message.data};\n",
       "              var metadata = message.metadata || {comm_id};\n",
       "              var msg = {content, metadata}\n",
       "              msg_handler(msg);\n",
       "              return messages.next().then(processIteratorResult);\n",
       "            }\n",
       "            return messages.next().then(processIteratorResult);\n",
       "          }\n",
       "        }) \n",
       "        var sendClosure = (data, metadata, buffers, disposeOnDone) => {\n",
       "          return comm_promise.then((comm) => {\n",
       "            comm.send(data, metadata, buffers, disposeOnDone);\n",
       "          });\n",
       "        };\n",
       "        var comm = {\n",
       "          send: sendClosure\n",
       "        };\n",
       "      }\n",
       "      window.PyViz.comms[comm_id] = comm;\n",
       "      return comm;\n",
       "    }\n",
       "    window.PyViz.comm_manager = new JupyterCommManager();\n",
       "    \n",
       "\n",
       "\n",
       "var JS_MIME_TYPE = 'application/javascript';\n",
       "var HTML_MIME_TYPE = 'text/html';\n",
       "var EXEC_MIME_TYPE = 'application/vnd.holoviews_exec.v0+json';\n",
       "var CLASS_NAME = 'output';\n",
       "\n",
       "/**\n",
       " * Render data to the DOM node\n",
       " */\n",
       "function render(props, node) {\n",
       "  var div = document.createElement(\"div\");\n",
       "  var script = document.createElement(\"script\");\n",
       "  node.appendChild(div);\n",
       "  node.appendChild(script);\n",
       "}\n",
       "\n",
       "/**\n",
       " * Handle when a new output is added\n",
       " */\n",
       "function handle_add_output(event, handle) {\n",
       "  var output_area = handle.output_area;\n",
       "  var output = handle.output;\n",
       "  if ((output.data == undefined) || (!output.data.hasOwnProperty(EXEC_MIME_TYPE))) {\n",
       "    return\n",
       "  }\n",
       "  var id = output.metadata[EXEC_MIME_TYPE][\"id\"];\n",
       "  var toinsert = output_area.element.find(\".\" + CLASS_NAME.split(' ')[0]);\n",
       "  if (id !== undefined) {\n",
       "    var nchildren = toinsert.length;\n",
       "    var html_node = toinsert[nchildren-1].children[0];\n",
       "    html_node.innerHTML = output.data[HTML_MIME_TYPE];\n",
       "    var scripts = [];\n",
       "    var nodelist = html_node.querySelectorAll(\"script\");\n",
       "    for (var i in nodelist) {\n",
       "      if (nodelist.hasOwnProperty(i)) {\n",
       "        scripts.push(nodelist[i])\n",
       "      }\n",
       "    }\n",
       "\n",
       "    scripts.forEach( function (oldScript) {\n",
       "      var newScript = document.createElement(\"script\");\n",
       "      var attrs = [];\n",
       "      var nodemap = oldScript.attributes;\n",
       "      for (var j in nodemap) {\n",
       "        if (nodemap.hasOwnProperty(j)) {\n",
       "          attrs.push(nodemap[j])\n",
       "        }\n",
       "      }\n",
       "      attrs.forEach(function(attr) { newScript.setAttribute(attr.name, attr.value) });\n",
       "      newScript.appendChild(document.createTextNode(oldScript.innerHTML));\n",
       "      oldScript.parentNode.replaceChild(newScript, oldScript);\n",
       "    });\n",
       "    if (JS_MIME_TYPE in output.data) {\n",
       "      toinsert[nchildren-1].children[1].textContent = output.data[JS_MIME_TYPE];\n",
       "    }\n",
       "    output_area._hv_plot_id = id;\n",
       "    if ((window.Bokeh !== undefined) && (id in Bokeh.index)) {\n",
       "      window.PyViz.plot_index[id] = Bokeh.index[id];\n",
       "    } else {\n",
       "      window.PyViz.plot_index[id] = null;\n",
       "    }\n",
       "  } else if (output.metadata[EXEC_MIME_TYPE][\"server_id\"] !== undefined) {\n",
       "    var bk_div = document.createElement(\"div\");\n",
       "    bk_div.innerHTML = output.data[HTML_MIME_TYPE];\n",
       "    var script_attrs = bk_div.children[0].attributes;\n",
       "    for (var i = 0; i < script_attrs.length; i++) {\n",
       "      toinsert[toinsert.length - 1].childNodes[1].setAttribute(script_attrs[i].name, script_attrs[i].value);\n",
       "    }\n",
       "    // store reference to server id on output_area\n",
       "    output_area._bokeh_server_id = output.metadata[EXEC_MIME_TYPE][\"server_id\"];\n",
       "  }\n",
       "}\n",
       "\n",
       "/**\n",
       " * Handle when an output is cleared or removed\n",
       " */\n",
       "function handle_clear_output(event, handle) {\n",
       "  var id = handle.cell.output_area._hv_plot_id;\n",
       "  var server_id = handle.cell.output_area._bokeh_server_id;\n",
       "  if (((id === undefined) || !(id in PyViz.plot_index)) && (server_id !== undefined)) { return; }\n",
       "  var comm = window.PyViz.comm_manager.get_client_comm(\"hv-extension-comm\", \"hv-extension-comm\", function () {});\n",
       "  if (server_id !== null) {\n",
       "    comm.send({event_type: 'server_delete', 'id': server_id});\n",
       "    return;\n",
       "  } else if (comm !== null) {\n",
       "    comm.send({event_type: 'delete', 'id': id});\n",
       "  }\n",
       "  delete PyViz.plot_index[id];\n",
       "  if ((window.Bokeh !== undefined) & (id in window.Bokeh.index)) {\n",
       "    var doc = window.Bokeh.index[id].model.document\n",
       "    doc.clear();\n",
       "    const i = window.Bokeh.documents.indexOf(doc);\n",
       "    if (i > -1) {\n",
       "      window.Bokeh.documents.splice(i, 1);\n",
       "    }\n",
       "  }\n",
       "}\n",
       "\n",
       "/**\n",
       " * Handle kernel restart event\n",
       " */\n",
       "function handle_kernel_cleanup(event, handle) {\n",
       "  delete PyViz.comms[\"hv-extension-comm\"];\n",
       "  window.PyViz.plot_index = {}\n",
       "}\n",
       "\n",
       "/**\n",
       " * Handle update_display_data messages\n",
       " */\n",
       "function handle_update_output(event, handle) {\n",
       "  handle_clear_output(event, {cell: {output_area: handle.output_area}})\n",
       "  handle_add_output(event, handle)\n",
       "}\n",
       "\n",
       "function register_renderer(events, OutputArea) {\n",
       "  function append_mime(data, metadata, element) {\n",
       "    // create a DOM node to render to\n",
       "    var toinsert = this.create_output_subarea(\n",
       "    metadata,\n",
       "    CLASS_NAME,\n",
       "    EXEC_MIME_TYPE\n",
       "    );\n",
       "    this.keyboard_manager.register_events(toinsert);\n",
       "    // Render to node\n",
       "    var props = {data: data, metadata: metadata[EXEC_MIME_TYPE]};\n",
       "    render(props, toinsert[0]);\n",
       "    element.append(toinsert);\n",
       "    return toinsert\n",
       "  }\n",
       "\n",
       "  events.on('output_added.OutputArea', handle_add_output);\n",
       "  events.on('output_updated.OutputArea', handle_update_output);\n",
       "  events.on('clear_output.CodeCell', handle_clear_output);\n",
       "  events.on('delete.Cell', handle_clear_output);\n",
       "  events.on('kernel_ready.Kernel', handle_kernel_cleanup);\n",
       "\n",
       "  OutputArea.prototype.register_mime_type(EXEC_MIME_TYPE, append_mime, {\n",
       "    safe: true,\n",
       "    index: 0\n",
       "  });\n",
       "}\n",
       "\n",
       "if (window.Jupyter !== undefined) {\n",
       "  try {\n",
       "    var events = require('base/js/events');\n",
       "    var OutputArea = require('notebook/js/outputarea').OutputArea;\n",
       "    if (OutputArea.prototype.mime_types().indexOf(EXEC_MIME_TYPE) == -1) {\n",
       "      register_renderer(events, OutputArea);\n",
       "    }\n",
       "  } catch(err) {\n",
       "  }\n",
       "}\n"
      ],
      "application/vnd.holoviews_load.v0+json": "\nif ((window.PyViz === undefined) || (window.PyViz instanceof HTMLElement)) {\n  window.PyViz = {comms: {}, comm_status:{}, kernels:{}, receivers: {}, plot_index: []}\n}\n\n\n    function JupyterCommManager() {\n    }\n\n    JupyterCommManager.prototype.register_target = function(plot_id, comm_id, msg_handler) {\n      if (window.comm_manager || ((window.Jupyter !== undefined) && (Jupyter.notebook.kernel != null))) {\n        var comm_manager = window.comm_manager || Jupyter.notebook.kernel.comm_manager;\n        comm_manager.register_target(comm_id, function(comm) {\n          comm.on_msg(msg_handler);\n        });\n      } else if ((plot_id in window.PyViz.kernels) && (window.PyViz.kernels[plot_id])) {\n        window.PyViz.kernels[plot_id].registerCommTarget(comm_id, function(comm) {\n          comm.onMsg = msg_handler;\n        });\n      } else if (typeof google != 'undefined' && google.colab.kernel != null) {\n        google.colab.kernel.comms.registerTarget(comm_id, (comm) => {\n          var messages = comm.messages[Symbol.asyncIterator]();\n          function processIteratorResult(result) {\n            var message = result.value;\n            console.log(message)\n            var content = {data: message.data, comm_id};\n            var buffers = []\n            for (var buffer of message.buffers || []) {\n              buffers.push(new DataView(buffer))\n            }\n            var metadata = message.metadata || {};\n            var msg = {content, buffers, metadata}\n            msg_handler(msg);\n            return messages.next().then(processIteratorResult);\n          }\n          return messages.next().then(processIteratorResult);\n        })\n      }\n    }\n\n    JupyterCommManager.prototype.get_client_comm = function(plot_id, comm_id, msg_handler) {\n      if (comm_id in window.PyViz.comms) {\n        return window.PyViz.comms[comm_id];\n      } else if (window.comm_manager || ((window.Jupyter !== undefined) && (Jupyter.notebook.kernel != null))) {\n        var comm_manager = window.comm_manager || Jupyter.notebook.kernel.comm_manager;\n        var comm = comm_manager.new_comm(comm_id, {}, {}, {}, comm_id);\n        if (msg_handler) {\n          comm.on_msg(msg_handler);\n        }\n      } else if ((plot_id in window.PyViz.kernels) && (window.PyViz.kernels[plot_id])) {\n        var comm = window.PyViz.kernels[plot_id].connectToComm(comm_id);\n        comm.open();\n        if (msg_handler) {\n          comm.onMsg = msg_handler;\n        }\n      } else if (typeof google != 'undefined' && google.colab.kernel != null) {\n        var comm_promise = google.colab.kernel.comms.open(comm_id)\n        comm_promise.then((comm) => {\n          window.PyViz.comms[comm_id] = comm;\n          if (msg_handler) {\n            var messages = comm.messages[Symbol.asyncIterator]();\n            function processIteratorResult(result) {\n              var message = result.value;\n              var content = {data: message.data};\n              var metadata = message.metadata || {comm_id};\n              var msg = {content, metadata}\n              msg_handler(msg);\n              return messages.next().then(processIteratorResult);\n            }\n            return messages.next().then(processIteratorResult);\n          }\n        }) \n        var sendClosure = (data, metadata, buffers, disposeOnDone) => {\n          return comm_promise.then((comm) => {\n            comm.send(data, metadata, buffers, disposeOnDone);\n          });\n        };\n        var comm = {\n          send: sendClosure\n        };\n      }\n      window.PyViz.comms[comm_id] = comm;\n      return comm;\n    }\n    window.PyViz.comm_manager = new JupyterCommManager();\n    \n\n\nvar JS_MIME_TYPE = 'application/javascript';\nvar HTML_MIME_TYPE = 'text/html';\nvar EXEC_MIME_TYPE = 'application/vnd.holoviews_exec.v0+json';\nvar CLASS_NAME = 'output';\n\n/**\n * Render data to the DOM node\n */\nfunction render(props, node) {\n  var div = document.createElement(\"div\");\n  var script = document.createElement(\"script\");\n  node.appendChild(div);\n  node.appendChild(script);\n}\n\n/**\n * Handle when a new output is added\n */\nfunction handle_add_output(event, handle) {\n  var output_area = handle.output_area;\n  var output = handle.output;\n  if ((output.data == undefined) || (!output.data.hasOwnProperty(EXEC_MIME_TYPE))) {\n    return\n  }\n  var id = output.metadata[EXEC_MIME_TYPE][\"id\"];\n  var toinsert = output_area.element.find(\".\" + CLASS_NAME.split(' ')[0]);\n  if (id !== undefined) {\n    var nchildren = toinsert.length;\n    var html_node = toinsert[nchildren-1].children[0];\n    html_node.innerHTML = output.data[HTML_MIME_TYPE];\n    var scripts = [];\n    var nodelist = html_node.querySelectorAll(\"script\");\n    for (var i in nodelist) {\n      if (nodelist.hasOwnProperty(i)) {\n        scripts.push(nodelist[i])\n      }\n    }\n\n    scripts.forEach( function (oldScript) {\n      var newScript = document.createElement(\"script\");\n      var attrs = [];\n      var nodemap = oldScript.attributes;\n      for (var j in nodemap) {\n        if (nodemap.hasOwnProperty(j)) {\n          attrs.push(nodemap[j])\n        }\n      }\n      attrs.forEach(function(attr) { newScript.setAttribute(attr.name, attr.value) });\n      newScript.appendChild(document.createTextNode(oldScript.innerHTML));\n      oldScript.parentNode.replaceChild(newScript, oldScript);\n    });\n    if (JS_MIME_TYPE in output.data) {\n      toinsert[nchildren-1].children[1].textContent = output.data[JS_MIME_TYPE];\n    }\n    output_area._hv_plot_id = id;\n    if ((window.Bokeh !== undefined) && (id in Bokeh.index)) {\n      window.PyViz.plot_index[id] = Bokeh.index[id];\n    } else {\n      window.PyViz.plot_index[id] = null;\n    }\n  } else if (output.metadata[EXEC_MIME_TYPE][\"server_id\"] !== undefined) {\n    var bk_div = document.createElement(\"div\");\n    bk_div.innerHTML = output.data[HTML_MIME_TYPE];\n    var script_attrs = bk_div.children[0].attributes;\n    for (var i = 0; i < script_attrs.length; i++) {\n      toinsert[toinsert.length - 1].childNodes[1].setAttribute(script_attrs[i].name, script_attrs[i].value);\n    }\n    // store reference to server id on output_area\n    output_area._bokeh_server_id = output.metadata[EXEC_MIME_TYPE][\"server_id\"];\n  }\n}\n\n/**\n * Handle when an output is cleared or removed\n */\nfunction handle_clear_output(event, handle) {\n  var id = handle.cell.output_area._hv_plot_id;\n  var server_id = handle.cell.output_area._bokeh_server_id;\n  if (((id === undefined) || !(id in PyViz.plot_index)) && (server_id !== undefined)) { return; }\n  var comm = window.PyViz.comm_manager.get_client_comm(\"hv-extension-comm\", \"hv-extension-comm\", function () {});\n  if (server_id !== null) {\n    comm.send({event_type: 'server_delete', 'id': server_id});\n    return;\n  } else if (comm !== null) {\n    comm.send({event_type: 'delete', 'id': id});\n  }\n  delete PyViz.plot_index[id];\n  if ((window.Bokeh !== undefined) & (id in window.Bokeh.index)) {\n    var doc = window.Bokeh.index[id].model.document\n    doc.clear();\n    const i = window.Bokeh.documents.indexOf(doc);\n    if (i > -1) {\n      window.Bokeh.documents.splice(i, 1);\n    }\n  }\n}\n\n/**\n * Handle kernel restart event\n */\nfunction handle_kernel_cleanup(event, handle) {\n  delete PyViz.comms[\"hv-extension-comm\"];\n  window.PyViz.plot_index = {}\n}\n\n/**\n * Handle update_display_data messages\n */\nfunction handle_update_output(event, handle) {\n  handle_clear_output(event, {cell: {output_area: handle.output_area}})\n  handle_add_output(event, handle)\n}\n\nfunction register_renderer(events, OutputArea) {\n  function append_mime(data, metadata, element) {\n    // create a DOM node to render to\n    var toinsert = this.create_output_subarea(\n    metadata,\n    CLASS_NAME,\n    EXEC_MIME_TYPE\n    );\n    this.keyboard_manager.register_events(toinsert);\n    // Render to node\n    var props = {data: data, metadata: metadata[EXEC_MIME_TYPE]};\n    render(props, toinsert[0]);\n    element.append(toinsert);\n    return toinsert\n  }\n\n  events.on('output_added.OutputArea', handle_add_output);\n  events.on('output_updated.OutputArea', handle_update_output);\n  events.on('clear_output.CodeCell', handle_clear_output);\n  events.on('delete.Cell', handle_clear_output);\n  events.on('kernel_ready.Kernel', handle_kernel_cleanup);\n\n  OutputArea.prototype.register_mime_type(EXEC_MIME_TYPE, append_mime, {\n    safe: true,\n    index: 0\n  });\n}\n\nif (window.Jupyter !== undefined) {\n  try {\n    var events = require('base/js/events');\n    var OutputArea = require('notebook/js/outputarea').OutputArea;\n    if (OutputArea.prototype.mime_types().indexOf(EXEC_MIME_TYPE) == -1) {\n      register_renderer(events, OutputArea);\n    }\n  } catch(err) {\n  }\n}\n"
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "select_mun =  MUN1\n",
      "files =  []\n"
     ]
    },
    {
     "data": {
      "text/html": [
       "\n",
       "<pre>Traceback (most recent call last):\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\pyviz_comms\\__init__.py&quot;, line 316, in _handle_msg\n",
       "    self._on_msg(msg)\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\panel\\viewable.py&quot;, line 259, in _on_msg\n",
       "    doc.unhold()\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\bokeh\\document\\document.py&quot;, line 668, in unhold\n",
       "    self._trigger_on_change(event)\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\bokeh\\document\\document.py&quot;, line 1151, in _trigger_on_change\n",
       "    self._with_self_as_curdoc(event.callback_invoker)\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\bokeh\\document\\document.py&quot;, line 1169, in _with_self_as_curdoc\n",
       "    return f()\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\bokeh\\util\\callback_manager.py&quot;, line 155, in invoke\n",
       "    callback(attr, old, new)\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\panel\\reactive.py&quot;, line 216, in _comm_change\n",
       "    self._process_events({attr: new})\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\panel\\reactive.py&quot;, line 187, in _process_events\n",
       "    self.param.set_param(**self._process_property_change(events))\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\param\\parameterized.py&quot;, line 1451, in set_param\n",
       "    self_._batch_call_watchers()\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\param\\parameterized.py&quot;, line 1578, in _batch_call_watchers\n",
       "    watcher.fn(*events)\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\panel\\param.py&quot;, line 407, in link_widget\n",
       "    self.object.param.set_param(**{p_name: change.new})\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\param\\parameterized.py&quot;, line 1451, in set_param\n",
       "    self_._batch_call_watchers()\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\param\\parameterized.py&quot;, line 1578, in _batch_call_watchers\n",
       "    watcher.fn(*events)\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\param\\parameterized.py&quot;, line 499, in caller\n",
       "    return getattr(self,n)()\n",
       "  File &quot;C:\\Users\\User\\miniconda3\\lib\\site-packages\\param\\parameterized.py&quot;, line 337, in _depends\n",
       "    return func(*args,**kw)\n",
       "  File &quot;&lt;ipython-input-31-78f1a34f535f&gt;&quot;, line 26, in _update_file\n",
       "    self.mun = mun[self.select_mun]\n",
       "NameError: name &#x27;mun&#x27; is not defined\n",
       "</pre>\n"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "application/vnd.holoviews_exec.v0+json": "",
      "text/html": [
       "<div id='1464'>\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "  <div class=\"bk-root\" id=\"44b7ab8b-df08-47bb-ba31-8f867c8f5868\" data-root-id=\"1464\"></div>\n",
       "</div>\n",
       "<script type=\"application/javascript\">(function(root) {\n",
       "  function embed_document(root) {\n",
       "    var docs_json = {\"aebabfa0-efea-4aaf-96ea-499cd1ade5f5\":{\"roots\":{\"references\":[{\"attributes\":{\"margin\":[5,10,5,10],\"options\":[[\"MUN1\",\"MUN1\"],[\"MUN2\",\"MUN2\"]],\"title\":\"Select mun\",\"value\":\"MUN1\"},\"id\":\"1467\",\"type\":\"Select\"},{\"attributes\":{\"margin\":[5,10,5,10],\"name\":\"\",\"text\":\"<b>Streets</b>\"},\"id\":\"1466\",\"type\":\"Div\"},{\"attributes\":{\"children\":[{\"id\":\"1466\"},{\"id\":\"1467\"},{\"id\":\"1468\"}],\"margin\":[5,5,5,5],\"min_width\":300,\"name\":\"Streets\",\"width\":300},\"id\":\"1465\",\"type\":\"Column\"},{\"attributes\":{\"margin\":[0,0,0,0],\"options\":[\"\\ud83d\\udcc13D Objects\",\"\\ud83d\\udcc1AppData\",\"\\ud83d\\udcc1Application Data\",\"\\ud83d\\udcc1Contacts\",\"\\ud83d\\udcc1Cookies\",\"\\ud83d\\udcc1Desktop\",\"\\ud83d\\udcc1Documents\",\"\\ud83d\\udcc1Downloads\",\"\\ud83d\\udcc1Dropbox\",\"\\ud83d\\udcc1Dropbox (Old)\",\"\\ud83d\\udcc1Favorites\",\"\\ud83d\\udcc1GK\",\"\\ud83d\\udcc1Links\",\"\\ud83d\\udcc1Local Settings\",\"\\ud83d\\udcc1MXD2map\",\"\\ud83d\\udcc1Macromedia\",\"\\ud83d\\udcc1MicrosoftEdgeBackups\",\"\\ud83d\\udcc1Music\",\"\\ud83d\\udcc1My Documents\",\"\\ud83d\\udcc1NetHood\",\"\\ud83d\\udcc1OneDrive\",\"\\ud83d\\udcc1Pictures\",\"\\ud83d\\udcc1PrintHood\",\"\\ud83d\\udcc1PycharmProjects\",\"\\ud83d\\udcc1Recent\",\"\\ud83d\\udcc1Saved Games\",\"\\ud83d\\udcc1Searches\",\"\\ud83d\\udcc1SendTo\",\"\\ud83d\\udcc1Start Menu\",\"\\ud83d\\udcc1Templates\",\"\\ud83d\\udcc1Tracing\",\"\\ud83d\\udcc1Videos\",\"\\ud83d\\udcc1Zero G Registry\",\"\\ud83d\\udcc1_ipython\",\"\\ud83d\\udcc1cache\",\"\\ud83d\\udcc1cachedir\",\"\\ud83d\\udcc1gvSIG\",\"\\ud83d\\udcc1images\",\"\\ud83d\\udcc1miniconda3\",\"\\ud83d\\udcc1postgre\",\"\\ud83d\\udcc1pysal_data\",\"\\ud83d\\udcc1scikit_learn_data\",\"\\ud83d\\udcc1sextante\",\"\\ud83d\\udcc1uDig\",\"A000000.px\",\"A000001.px\",\"A000002.px\",\"A_A - Copy.ipynb\",\"A_A.ipynb\",\"A_FloatMap.ipynb\",\"A_Izbori2020.ipynb\",\"A_MrTetiranja.ipynb\",\"A_Mravka.ipynb\",\"A_Mravka1.ipynb\",\"A_Mravka_Def.ipynb\",\"A_Mravkamin.ipynb\",\"A_Mravkapred.ipynb\",\"A_Mravkax.ipynb\",\"A_example.ipynb\",\"AltairPiramidaKarta_Vazi.ipynb\",\"AnketiDashboardDef.ipynb\",\"AnkjetaKorisnici.ipynb\",\"CONTINUE.dws\",\"Corona.ipynb\",\"Corona1.ipynb\",\"Covid.ipynb\",\"CrossSelector.ipynb\",\"Customization.ipynb\",\"Dashboard_Servisi.ipynb\",\"ECharts.ipynb\",\"EvidencijaPXWeb.ipynb\",\"GeopyGeocoderPrimeri.py\",\"Instagram.ipynb\",\"KonverzijJupyter_Py.bat\",\"KonverzijaShp.ipynb\",\"Konverzija_Shp_1.ipynb\",\"MIT.ipynb\",\"ML.ipynb\",\"ML_PP.ipynb\",\"ML_PP_1.ipynb\",\"M_Elektronika.ipynb\",\"M_Pazar3.ipynb\",\"Machinelearning_PPS.ipynb\",\"Macromedia_Flex_Builder_2_Alpha_1_InstallLog.log\",\"MakStataProektt.txt\",\"Manual_Corsa_2010_hr.pdf\",\"MapNotebook.ipynb\",\"MenuvajMetaID za PCAxis.ipynb\",\"MultiSelect.ipynb\",\"NIPP.ipynb\",\"NIPP_CUK.ipynb\",\"NTUSER.DAT\",\"NTUSER.DAT{b394265b-18b2-11ea-a815-000d3aa4c730}.TM.blf\",\"NTUSER.DAT{b394265b-18b2-11ea-a815-000d3aa4c730}.TMContainer00000000000000000001.regtrans-ms\",\"NTUSER.DAT{b394265b-18b2-11ea-a815-000d3aa4c730}.TMContainer00000000000000000002.regtrans-ms\",\"Nadvtrg_en.ipynb\",\"Nadvtrg_mk.ipynb\",\"Nadvtrg_mkCopy.ipynb\",\"OWSLib WMS.ipynb\",\"OpenData.ipynb\",\"Openpyxl primeri.ipynb\",\"PProbaAltair.ipynb\",\"PanelTestovi.ipynb\",\"Param.ipynb\",\"Pipeline Primer.ipynb\",\"Pipelines.ipynb\",\"PopAplDashboard.ipynb\",\"Primer Password.ipynb\",\"Proba.ipynb\",\"ProbaAltair.ipynb\",\"REGIO PYSAL.ipynb\",\"RadioButtonGroup.ipynb\",\"Revizija_Testovi.ipynb\",\"SDMX_Pandas.ipynb\",\"SciTE.session\",\"TematskaKarta.ipynb\",\"Templates.ipynb\",\"Testiranja.ipynb\",\"Thumbs.db\",\"TimeMK.ipynb\",\"TuristiMeseci.csv\",\"TurizamNov.ipynb\",\"TurizamNovDef.ipynb\",\"TurizamNovDef_en.ipynb\",\"Turizam_mk.ipynb\",\"Untitled.ipynb\",\"Untitled1.ipynb\",\"Untitled10.ipynb\",\"Untitled11.ipynb\",\"Untitled12.ipynb\",\"Untitled13.ipynb\",\"Untitled14.ipynb\",\"Untitled15.ipynb\",\"Untitled16.ipynb\",\"Untitled17.ipynb\",\"Untitled18.ipynb\",\"Untitled19.ipynb\",\"Untitled2.ipynb\",\"Untitled20.ipynb\",\"Untitled21.ipynb\",\"Untitled23.ipynb\",\"Untitled3.ipynb\",\"Untitled4.ipynb\",\"Untitled5.ipynb\",\"Untitled6.ipynb\",\"Untitled7-Copy1.ipynb\",\"Untitled7.ipynb\",\"Untitled8.ipynb\",\"Untitled9.ipynb\",\"WebScrapping_Booking.ipynb\",\"WorldBank data.ipynb\",\"Z_eks1_doi_csv1-en.ipynb\",\"Z_eks1_doi_csv_nor.ipynb\",\"Z_klass_kommune2020.ipynb\",\"Z_komm-nr-id-nor.ipynb\",\"Z_konkurs-dateconv-en.ipynb\",\"Z_konkurs-datokonv.ipynb\",\"Z_kostra-koder-nor.ipynb\",\"Z_kt-csv-en.ipynb\",\"Z_kt-csv-nor.ipynb\",\"Z_laks-no.ipynb\",\"Z_nr-datokonv-en.ipynb\",\"Z_nr-datokonv.ipynb\",\"Z_text-code-en.ipynb\",\"Z_text-code-nor.ipynb\",\"Z_two-tables-one-chart-en.ipynb\",\"Z_two-tables-one-chart_nor.ipynb\",\"altair-data-01b53a5d6ce44aaffffaf0ffdc6aa919.json\",\"altair-data-49732e14c28f849c01dc33012ed49942.json\",\"altair-data-684f76567d2e09e5a29816ad74084926.json\",\"altair-data-752d3f2fee238b6820805a8802659047.json\",\"altair-data-a13723086edbebcd9e6a225c9f9d8307.json\",\"altair-data-f9874c4bf61cb279895edc54ef484e91.json\",\"appMobiToolkit.props\",\"crossfilter.py\",\"daemonprocess.txt\",\"debug.log\",\"din.ipynb\",\"distribution_tabs.ipynb\",\"download_upload_csv.ipynb\",\"dynamic_tabs.ipynb\",\"dynamic_widget_values.ipynb\",\"e4b247eb1319192c200.details\",\"e4b247eb1319192c200.notes\",\"gapminders.ipynb\",\"geonext.ini\",\"glaciers.ipynb\",\"gmap_plot.html\",\"ia_remove.sh6830.tmp\",\"ia_remove.sh8570.tmp\",\"map.png\",\"ntuser.dat.LOG1\",\"ntuser.dat.LOG2\",\"ntuser.ini\",\"opendata.py\",\"persistent_state\",\"pgadmin4-3.0-x86.exe\",\"plot_with_columns.ipynb\",\"portfolio-optimizer.ipynb\",\"precedence.ipynb\",\"reactive_plots.ipynb\",\"saga_gui.cfg\",\"saga_gui.ini\",\"stocks_altair.ipynb\",\"tematikdef.ipynb\",\"vega_heatmap_link.ipynb\",\"xInteraktivniNadvoresna_1301_Def.ipynb\",\"\\u041c_Marketi.ipynb\"],\"size\":10,\"sizing_mode\":\"stretch_both\"},\"id\":\"1480\",\"type\":\"MultiSelect\"},{\"attributes\":{\"disabled\":true,\"icon\":null,\"label\":\"\\u25c0\",\"margin\":[5,10,0,0],\"min_width\":25,\"subscribed_events\":[\"button_click\"],\"width\":25},\"id\":\"1470\",\"type\":\"Button\"},{\"attributes\":{\"margin\":[0,0,10,0],\"placeholder\":\"Filter available options\",\"width_policy\":\"max\"},\"id\":\"1479\",\"type\":\"TextInput\"},{\"attributes\":{\"margin\":[5,5,5,5],\"name\":\"VSpacer00555\",\"sizing_mode\":\"stretch_height\"},\"id\":\"1482\",\"type\":\"Spacer\"},{\"attributes\":{\"disabled\":true,\"margin\":[0,0,0,0],\"max_length\":5000,\"placeholder\":\"To select an item highlight it on the left and use the arrow button to move it to the right.\",\"sizing_mode\":\"stretch_both\"},\"id\":\"1490\",\"type\":\"TextAreaInput\"},{\"attributes\":{\"disabled\":true,\"icon\":null,\"label\":\"\\u2b06\",\"margin\":[5,10,5,10],\"min_width\":25,\"subscribed_events\":[\"button_click\"],\"width\":25},\"id\":\"1472\",\"type\":\"Button\"},{\"attributes\":{\"disabled\":true,\"icon\":null,\"label\":\"\\u25b6\",\"margin\":[5,10,5,10],\"min_width\":25,\"subscribed_events\":[\"button_click\"],\"width\":25},\"id\":\"1471\",\"type\":\"Button\"},{\"attributes\":{\"children\":[{\"id\":\"1465\"}],\"margin\":[0,0,0,0],\"name\":\"Column00569\"},\"id\":\"1464\",\"type\":\"Column\"},{\"attributes\":{\"icon\":null,\"label\":\">>\",\"margin\":[5,10,5,10],\"min_width\":50,\"subscribed_events\":[\"button_click\"],\"width\":50},\"id\":\"1484\",\"type\":\"Button\"},{\"attributes\":{\"children\":[{\"id\":\"1482\"},{\"id\":\"1483\"},{\"id\":\"1486\"}],\"margin\":[0,0,0,0],\"name\":\"Column00557\"},\"id\":\"1481\",\"type\":\"Column\"},{\"attributes\":{\"children\":[{\"id\":\"1484\"},{\"id\":\"1485\"}],\"margin\":[0,5,0,5],\"name\":\"Column00554\"},\"id\":\"1483\",\"type\":\"Column\"},{\"attributes\":{\"children\":[{\"id\":\"1477\"},{\"id\":\"1481\"},{\"id\":\"1487\"}],\"margin\":[0,0,0,0],\"name\":\"\",\"sizing_mode\":\"stretch_both\",\"width\":600},\"id\":\"1476\",\"type\":\"Row\"},{\"attributes\":{\"icon\":null,\"label\":\"<<\",\"margin\":[5,10,5,10],\"min_width\":50,\"subscribed_events\":[\"button_click\"],\"width\":50},\"id\":\"1485\",\"type\":\"Button\"},{\"attributes\":{\"margin\":[5,5,5,5],\"name\":\"VSpacer00556\",\"sizing_mode\":\"stretch_height\"},\"id\":\"1486\",\"type\":\"Spacer\"},{\"attributes\":{\"margin\":[5,10,5,10],\"value\":\"C:\\\\Users\\\\User\",\"width_policy\":\"max\"},\"id\":\"1473\",\"type\":\"TextInput\"},{\"attributes\":{\"children\":[{\"id\":\"1488\"},{\"id\":\"1489\"},{\"id\":\"1490\"}],\"margin\":[0,0,0,0],\"name\":\"Column00553\",\"sizing_mode\":\"stretch_both\"},\"id\":\"1487\",\"type\":\"Column\"},{\"attributes\":{\"css_classes\":[\"markdown\"],\"margin\":[0,0,0,0],\"name\":\"Markdown00565\",\"text\":\"&lt;h3&gt;Selected files&lt;/h3&gt;\"},\"id\":\"1488\",\"type\":\"panel.models.markup.HTML\"},{\"attributes\":{\"client_comm_id\":\"2df76c0985c94d12ba4b603c7e5274cd\",\"comm_id\":\"60164fcd791548e2a0243f582a70029a\",\"plot_id\":\"1464\"},\"id\":\"1491\",\"type\":\"panel.models.comm_manager.CommManager\"},{\"attributes\":{\"disabled\":true,\"icon\":null,\"label\":\"\\u2b07\",\"margin\":[5,15,0,0],\"min_width\":25,\"subscribed_events\":[\"button_click\"],\"width\":25},\"id\":\"1474\",\"type\":\"Button\"},{\"attributes\":{\"children\":[{\"id\":\"1478\"},{\"id\":\"1479\"},{\"id\":\"1480\"}],\"margin\":[0,0,0,0],\"name\":\"Column00552\",\"sizing_mode\":\"stretch_both\"},\"id\":\"1477\",\"type\":\"Column\"},{\"attributes\":{\"css_classes\":[\"markdown\"],\"margin\":[0,0,0,0],\"name\":\"Markdown00567\",\"text\":\"&lt;h3&gt;File Browser&lt;/h3&gt;\"},\"id\":\"1478\",\"type\":\"panel.models.markup.HTML\"},{\"attributes\":{\"children\":[{\"id\":\"1469\"},{\"id\":\"1475\"},{\"id\":\"1476\"}],\"margin\":[5,10,20,10],\"name\":\"Files\"},\"id\":\"1468\",\"type\":\"Column\"},{\"attributes\":{\"children\":[{\"id\":\"1470\"},{\"id\":\"1471\"},{\"id\":\"1472\"},{\"id\":\"1473\"},{\"id\":\"1474\"}],\"margin\":[0,0,0,0],\"name\":\"Row00563\",\"width_policy\":\"max\"},\"id\":\"1469\",\"type\":\"Row\"},{\"attributes\":{\"margin\":[0,0,0,0],\"name\":\"Divider00564\",\"style\":{\"height\":\"100%\",\"width\":\"100%\"},\"text\":\"<hr style=\\\"margin: 0px\\\">\",\"width_policy\":\"fit\"},\"id\":\"1475\",\"type\":\"Div\"},{\"attributes\":{\"margin\":[0,0,10,0],\"placeholder\":\"Filter selected options\",\"width_policy\":\"max\"},\"id\":\"1489\",\"type\":\"TextInput\"}],\"root_ids\":[\"1464\",\"1491\"]},\"title\":\"Bokeh Application\",\"version\":\"2.2.3\"}};\n",
       "    var render_items = [{\"docid\":\"aebabfa0-efea-4aaf-96ea-499cd1ade5f5\",\"root_ids\":[\"1464\"],\"roots\":{\"1464\":\"44b7ab8b-df08-47bb-ba31-8f867c8f5868\"}}];\n",
       "    root.Bokeh.embed.embed_items_notebook(docs_json, render_items);\n",
       "  }\n",
       "  if (root.Bokeh !== undefined && root.Bokeh.Panel !== undefined) {\n",
       "    embed_document(root);\n",
       "  } else {\n",
       "    var attempts = 0;\n",
       "    var timer = setInterval(function(root) {\n",
       "      if (root.Bokeh !== undefined && root.Bokeh.Panel !== undefined) {\n",
       "        clearInterval(timer);\n",
       "        embed_document(root);\n",
       "      } else if (document.readyState == \"complete\") {\n",
       "        attempts++;\n",
       "        if (attempts > 100) {\n",
       "          clearInterval(timer);\n",
       "          console.log(\"Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing\");\n",
       "        }\n",
       "      }\n",
       "    }, 10, root)\n",
       "  }\n",
       "})(window);</script>"
      ],
      "text/plain": [
       "Column\n",
       "    [0] Param(Streets, parameters=['select_mun', 'files'], widgets={'select_mun': {'widget_ty...})"
      ]
     },
     "execution_count": 31,
     "metadata": {
      "application/vnd.holoviews_exec.v0+json": {
       "id": "1464"
      }
     },
     "output_type": "execute_result"
    }
   ],
   "source": [
    "import os\n",
    "import geopandas as gpd\n",
    "import pandas as pd\n",
    "import panel as pn\n",
    "import param\n",
    "pn.extension()\n",
    "\n",
    "\n",
    "class Streets(param.Parameterized):\n",
    "    mun = {'MUN1':'Mun1', 'MUN2':'Mun2'} # selecting from the selector municipality to get the path (select MUN1 to get path G:\\\\Test\\\\Mun1)\n",
    "    \n",
    "    select_mun = param.Selector(default=list(mun.keys())[0], objects=list(mun.keys())) selector for municipality\n",
    "    files = param.MultiFileSelector() # to select final folder in the path\n",
    "    \n",
    "\n",
    "    view = param.Parameter()\n",
    "\n",
    "    def __init__(self, **params):\n",
    "        super().__init__(**params)\n",
    "        self.folder = 'G:\\\\Test'                   #change to existing starting folder\n",
    "        self.view = self._create_view()\n",
    "        \n",
    "    @param.depends('select_mun', watch=True)\n",
    "    def _update_file(self):\n",
    "               \n",
    "        self.mun = mun[self.select_mun]\n",
    "        self.munfolder = os.path.join(self.folder, self.mun)\n",
    "        self.outputfilename = self.mun + \"_control.xlsx\"\n",
    "        self.outputpat = os.path.join(self.munfolder, self.outputfilename)\n",
    "        \n",
    "        self.param['files'].path = self.munfolder   # file selector is not updated. Showing default path on computer. It is not updated to the folder G:\\\\Test\\\\Mun1\n",
    "        \n",
    "        print('files', self.files)\n",
    "        \n",
    "    \n",
    "    def _create_view(self):\n",
    "        \n",
    "        panel_left = pn.Param(\n",
    "            self, \n",
    "            parameters=[\"select_mun\", \"files\"],\n",
    "            widgets={\n",
    "                'select_mun': {'widget_type': pn.widgets.Select}, \n",
    "                'files': {'widget_type': pn.widgets.FileSelector}}\n",
    "            )\n",
    "        \n",
    "        print('select_mun = ',self.select_mun)\n",
    "        print('files = ',self.files)\n",
    "        \n",
    "        return pn.Column(panel_left)\n",
    "    \n",
    "Streets().view.servable()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 20,
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": 22,
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.6.12"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
